#include "common.h"





#if _Debug





UINT GlobalDebugPrintLevel = 5;





void DebugVPrintf (UINT const Level, PCTSTR const Fmt, va_list const List) {

  if (Level >= GlobalDebugPrintLevel) {

    wchar_t Buf [512];

    wchar_t const Delim = (Level == 9)? L'*' : L' ';

    int N = wsprintf (Buf, ProductShortName L"%c%05u%c", Delim, GetTickCount () % 100000, Delim);

    N += wvsprintf (Buf + N, Fmt, List);

    wcscpy (Buf + N, L"\n");

    Assert (N + 1 < NumArrayElems (Buf));

    OutputDebugString (Buf);

  }

}





void _cdecl DebugPrintf (UINT const Level, PCTSTR const Fmt, ...) {

  if (Level >= GlobalDebugPrintLevel) {

    va_list List;

    va_start (List, Fmt);
    DebugVPrintf (Level, Fmt, List);
    va_end (List);

  }

}





#endif // _DEBUG
