#include "common.h"





static void vMessage (PCTSTR Format, va_list Args, UINT Type) {

  wchar_t Str [512];

  wvsprintf (Str, Format, Args);

  Debug (8, L"Message: %s", Str);

  MessageBox (HWND_DESKTOP, Str, ProductShortName, Type);
  
}





void _cdecl Message (UINT Type, PCTSTR Format, ...) {

  va_list Args;

  va_start (Args, Format);
  vMessage (Format, Args, Type);
  va_end (Args);
  
}





void _cdecl Info (PCTSTR Format, ...) {

  if (!NoInfoMessages) {

    va_list Args;

    va_start (Args, Format);
    vMessage (Format, Args, MB_ICONINFORMATION | MB_OK);
    va_end (Args);

  }
  
}





void _cdecl Warning (PCTSTR Format, ...) {

  if (!(ProcessingStarted && NoErrorMessages)) {

    va_list Args;

    va_start (Args, Format);
    vMessage (Format, Args, MB_ICONWARNING | MB_OK);
    va_end (Args);

  }
  
}





void _cdecl Error (PCTSTR Format, ...) {

  if (!(ProcessingStarted && NoErrorMessages)) {

    va_list Args;

    va_start (Args, Format);
    vMessage (Format, Args, MB_ICONERROR | MB_OK);
    va_end (Args);

  }
  
}





PCTSTR ErrorText (DWORD Code) {

  static wchar_t Text [512];

  DWORD const Err = GetLastError ();

  int const N = wsprintf (Text, (TestBits (Code, 0xffff0000)? L"%#x - " : L"%u - "), Code);

  wchar_t * cp = Text + N;
  UINT Avail = NumArrayElems (Text) - N - 1;

  FormatMessage (
    FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS | FORMAT_MESSAGE_MAX_WIDTH_MASK,
    nullptr,
    Code,
    MAKELANGID (LANG_NEUTRAL, SUBLANG_DEFAULT),
    cp,
    Avail,
    nullptr 
  );

  cp += wcslen (cp) - 1;

  if (*cp == L' ') {

    SetEOS (cp);

  }

  SetLastError (Err);

  return Text;

}





PCTSTR LastErrorText (void) {

  return ErrorText (GetLastError ());

}
